

class HardCoded:
    """Constants used throughout the application.

    All hard coded settings/data that are not actual/official configuration options for Flask, Celery, or their
    extensions goes here.
    """
    ADMINS = ['adam.schubert@sg1-game.net']
    ENVIRONMENT = property(lambda self: self.__class__.__name__)


class Config(HardCoded):
    """Default Flask configuration inherited by all environments. Use this for development environments."""
    DEBUG = True
    TESTING = False
    SECRET_KEY = "i_don't_want_my_cookies_expiring_while_developing_portal_api"  # nosec: B105
    PORT = 5000
    HOST = '127.0.0.1'
    GAMMU_CONFIG_PATH = '/etc/gammu-smsdrc'
    USERS = {'demo': 'demo'}


class Testing(Config):
    TESTING = True


class Production(Config):
    DEBUG = False
    SECRET_KEY = None  # type: ignore [assignment]
    PORT = None  # type: ignore [assignment]
    HOST = None  # type: ignore [assignment]
    USERS = None  # type: ignore [assignment]
