from typing import Tuple
import flask
from gammu_smsd_api.blueprints import api_smsd
from gammu_smsd_api.extensions import http_basic_auth, gammu_flask


__author__ = "Adam Schubert"


@api_smsd.route('/inject-sms', methods=['POST'])
@http_basic_auth.login_required()  # type: ignore [misc]
def inject_sms() -> Tuple[flask.Response, int]:
    if not flask.request.json:
        return flask.jsonify({'message': 'Content type has to be text/json with JSON body'}), 400
    number = flask.request.json.get('number')
    sms_info = flask.request.json.get('sms_info')
    smsc = flask.request.json.get('smsc')

    if not number:
        return flask.jsonify({'message': 'number is required'}), 400

    if not sms_info:
        return flask.jsonify({'message': 'sms_info is required'}), 400

    sms_id = gammu_flask.inject_sms(number, sms_info, smsc)

    return flask.jsonify({
        'id': sms_id,
    }), 200


@api_smsd.route('/status', methods=['GET'])
@http_basic_auth.login_required()  # type: ignore [misc]
def get_status() -> Tuple[flask.Response, int]:
    return flask.jsonify(gammu_flask.get_status()), 200
